
package net.mcreator.mnthings.entity;

import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.fml.network.NetworkHooks;
import net.minecraftforge.fml.network.FMLPlayMessages;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.common.DungeonHooks;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.world.gen.Heightmap;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.DamageSource;
import net.minecraft.network.IPacket;
import net.minecraft.item.SpawnEggItem;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.Item;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.monster.MonsterEntity;
import net.minecraft.entity.ai.goal.SwimGoal;
import net.minecraft.entity.ai.goal.RandomWalkingGoal;
import net.minecraft.entity.ai.goal.NearestAttackableTargetGoal;
import net.minecraft.entity.ai.goal.MeleeAttackGoal;
import net.minecraft.entity.ai.goal.LookRandomlyGoal;
import net.minecraft.entity.ai.goal.HurtByTargetGoal;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.EntityType;
import net.minecraft.entity.EntitySpawnPlacementRegistry;
import net.minecraft.entity.EntityClassification;
import net.minecraft.entity.Entity;
import net.minecraft.entity.CreatureAttribute;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.mnthings.MnthingsModElements;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@MnthingsModElements.ModElement.Tag
public class AbandonedPuppetEntity extends MnthingsModElements.ModElement {
	public static EntityType entity = null;
	public AbandonedPuppetEntity(MnthingsModElements instance) {
		super(instance, 16);
		FMLJavaModLoadingContext.get().getModEventBus().register(this);
	}

	@Override
	public void initElements() {
		entity = (EntityType.Builder.<CustomEntity>create(CustomEntity::new, EntityClassification.MONSTER).setShouldReceiveVelocityUpdates(true)
				.setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(CustomEntity::new).size(0.6f, 7f)).build("abandoned_puppet")
						.setRegistryName("abandoned_puppet");
		elements.entities.add(() -> entity);
		elements.items.add(() -> new SpawnEggItem(entity, -5264259, -5411475, new Item.Properties().group(ItemGroup.MISC))
				.setRegistryName("abandoned_puppet_spawn_egg"));
	}

	@Override
	public void init(FMLCommonSetupEvent event) {
		for (Biome biome : ForgeRegistries.BIOMES.getValues()) {
			biome.getSpawns(EntityClassification.MONSTER).add(new Biome.SpawnListEntry(entity, 45, 4, 4));
		}
		EntitySpawnPlacementRegistry.register(entity, EntitySpawnPlacementRegistry.PlacementType.ON_GROUND, Heightmap.Type.MOTION_BLOCKING_NO_LEAVES,
				MonsterEntity::canMonsterSpawn);
		DungeonHooks.addDungeonMob(entity, 180);
	}

	@SubscribeEvent
	@OnlyIn(Dist.CLIENT)
	public void registerModels(ModelRegistryEvent event) {
		RenderingRegistry.registerEntityRenderingHandler(entity, renderManager -> {
			return new MobRenderer(renderManager, new Modelcustom_model(), 0.5f) {
				@Override
				public ResourceLocation getEntityTexture(Entity entity) {
					return new ResourceLocation("mnthings:textures/abandonated_puppet.png");
				}
			};
		});
	}
	public static class CustomEntity extends MonsterEntity {
		public CustomEntity(FMLPlayMessages.SpawnEntity packet, World world) {
			this(entity, world);
		}

		public CustomEntity(EntityType<CustomEntity> type, World world) {
			super(type, world);
			experienceValue = 2;
			setNoAI(false);
		}

		@Override
		public IPacket<?> createSpawnPacket() {
			return NetworkHooks.getEntitySpawningPacket(this);
		}

		@Override
		protected void registerGoals() {
			super.registerGoals();
			this.targetSelector.addGoal(1, new NearestAttackableTargetGoal(this, PlayerEntity.class, true, false));
			this.goalSelector.addGoal(2, new MeleeAttackGoal(this, 1.2, false));
			this.goalSelector.addGoal(3, new RandomWalkingGoal(this, 1));
			this.targetSelector.addGoal(4, new HurtByTargetGoal(this));
			this.goalSelector.addGoal(5, new LookRandomlyGoal(this));
			this.goalSelector.addGoal(6, new SwimGoal(this));
		}

		@Override
		public CreatureAttribute getCreatureAttribute() {
			return CreatureAttribute.UNDEAD;
		}

		@Override
		public net.minecraft.util.SoundEvent getHurtSound(DamageSource ds) {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.generic.hurt"));
		}

		@Override
		public net.minecraft.util.SoundEvent getDeathSound() {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.generic.death"));
		}

		@Override
		protected void registerAttributes() {
			super.registerAttributes();
			if (this.getAttribute(SharedMonsterAttributes.MOVEMENT_SPEED) != null)
				this.getAttribute(SharedMonsterAttributes.MOVEMENT_SPEED).setBaseValue(0.3);
			if (this.getAttribute(SharedMonsterAttributes.MAX_HEALTH) != null)
				this.getAttribute(SharedMonsterAttributes.MAX_HEALTH).setBaseValue(24);
			if (this.getAttribute(SharedMonsterAttributes.ARMOR) != null)
				this.getAttribute(SharedMonsterAttributes.ARMOR).setBaseValue(2);
			if (this.getAttribute(SharedMonsterAttributes.ATTACK_DAMAGE) == null)
				this.getAttributes().registerAttribute(SharedMonsterAttributes.ATTACK_DAMAGE);
			this.getAttribute(SharedMonsterAttributes.ATTACK_DAMAGE).setBaseValue(8);
			if (this.getAttribute(SharedMonsterAttributes.KNOCKBACK_RESISTANCE) == null)
				this.getAttributes().registerAttribute(SharedMonsterAttributes.KNOCKBACK_RESISTANCE);
			this.getAttribute(SharedMonsterAttributes.KNOCKBACK_RESISTANCE).setBaseValue(8D);
			if (this.getAttribute(SharedMonsterAttributes.ATTACK_KNOCKBACK) == null)
				this.getAttributes().registerAttribute(SharedMonsterAttributes.ATTACK_KNOCKBACK);
			this.getAttribute(SharedMonsterAttributes.ATTACK_KNOCKBACK).setBaseValue(3D);
		}
	}

	// Made with Blockbench 3.8.4
	// Exported for Minecraft version 1.15 - 1.16
	// Paste this class into your mod and generate all required imports
	public static class Modelcustom_model extends EntityModel<Entity> {
		private final ModelRenderer piernaizq;
		private final ModelRenderer piernader;
		private final ModelRenderer cuerpo;
		private final ModelRenderer cabeza;
		private final ModelRenderer brazoizq;
		private final ModelRenderer brazoder;
		public Modelcustom_model() {
			textureWidth = 32;
			textureHeight = 32;
			piernaizq = new ModelRenderer(this);
			piernaizq.setRotationPoint(-1.5F, 16.0F, 0.5F);
			piernaizq.setTextureOffset(12, 12).addBox(-0.5F, 0.0F, -0.5F, 1.0F, 8.0F, 1.0F, 0.0F, false);
			piernaizq.setTextureOffset(20, 0).addBox(-0.5F, 7.0F, -1.5F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			piernader = new ModelRenderer(this);
			piernader.setRotationPoint(0.5F, 16.0F, 0.5F);
			piernader.setTextureOffset(8, 12).addBox(-0.5F, 0.0F, -0.5F, 1.0F, 8.0F, 1.0F, 0.0F, false);
			piernader.setTextureOffset(25, 0).addBox(-0.5F, 7.0F, -1.5F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cuerpo = new ModelRenderer(this);
			cuerpo.setRotationPoint(-0.5F, 11.0F, 0.5F);
			cuerpo.setTextureOffset(8, 6).addBox(-1.5F, 0.0F, -0.5F, 3.0F, 5.0F, 1.0F, 0.0F, false);
			cuerpo.setTextureOffset(9, 0).addBox(-0.5F, 1.0F, -1.5F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza = new ModelRenderer(this);
			cabeza.setRotationPoint(-0.6F, 11.0F, 0.4F);
			cabeza.setTextureOffset(0, 0).addBox(-1.4F, -3.0F, -1.4F, 3.0F, 3.0F, 3.0F, 0.0F, false);
			cabeza.setTextureOffset(23, 7).addBox(-0.4F, -2.0F, -3.4F, 1.0F, 1.0F, 2.0F, 0.0F, false);
			brazoizq = new ModelRenderer(this);
			brazoizq.setRotationPoint(-2.0F, 11.0F, 0.5F);
			brazoizq.setTextureOffset(4, 6).addBox(-1.0F, 0.0F, -0.5F, 1.0F, 10.0F, 1.0F, 0.0F, false);
			brazoder = new ModelRenderer(this);
			brazoder.setRotationPoint(1.0F, 11.0F, 0.5F);
			brazoder.setTextureOffset(0, 6).addBox(0.0F, 0.0F, -0.5F, 1.0F, 10.0F, 1.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			piernaizq.render(matrixStack, buffer, packedLight, packedOverlay);
			piernader.render(matrixStack, buffer, packedLight, packedOverlay);
			cuerpo.render(matrixStack, buffer, packedLight, packedOverlay);
			cabeza.render(matrixStack, buffer, packedLight, packedOverlay);
			brazoizq.render(matrixStack, buffer, packedLight, packedOverlay);
			brazoder.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.brazoizq.rotateAngleX = MathHelper.cos(f * 0.6662F) * f1;
			this.brazoder.rotateAngleX = MathHelper.cos(f * 0.6662F + (float) Math.PI) * f1;
			this.piernaizq.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.cabeza.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.cabeza.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.piernader.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
		}
	}
}
