
package net.mcreator.mnthings.entity;

import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.fml.network.NetworkHooks;
import net.minecraftforge.fml.network.FMLPlayMessages;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.common.DungeonHooks;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.world.gen.Heightmap;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.DamageSource;
import net.minecraft.particles.ParticleTypes;
import net.minecraft.network.IPacket;
import net.minecraft.item.SpawnEggItem;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.Item;
import net.minecraft.inventory.EquipmentSlotType;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.monster.MonsterEntity;
import net.minecraft.entity.ai.goal.SwimGoal;
import net.minecraft.entity.ai.goal.RandomWalkingGoal;
import net.minecraft.entity.ai.goal.NearestAttackableTargetGoal;
import net.minecraft.entity.ai.goal.MeleeAttackGoal;
import net.minecraft.entity.ai.goal.LookRandomlyGoal;
import net.minecraft.entity.ai.goal.HurtByTargetGoal;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.EntityType;
import net.minecraft.entity.EntitySpawnPlacementRegistry;
import net.minecraft.entity.EntityClassification;
import net.minecraft.entity.Entity;
import net.minecraft.entity.CreatureEntity;
import net.minecraft.entity.CreatureAttribute;
import net.minecraft.client.renderer.texture.OverlayTexture;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.layers.LayerRenderer;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.IEntityRenderer;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.renderer.IRenderTypeBuffer;
import net.minecraft.block.Blocks;

import net.mcreator.mnthings.MnthingsModElements;

import java.util.Random;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@MnthingsModElements.ModElement.Tag
public class AntEntity extends MnthingsModElements.ModElement {
	public static EntityType entity = null;
	public AntEntity(MnthingsModElements instance) {
		super(instance, 3);
		FMLJavaModLoadingContext.get().getModEventBus().register(this);
	}

	@Override
	public void initElements() {
		entity = (EntityType.Builder.<CustomEntity>create(CustomEntity::new, EntityClassification.MONSTER).setShouldReceiveVelocityUpdates(true)
				.setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(CustomEntity::new).size(0.6f, 0.4f)).build("ant")
						.setRegistryName("ant");
		elements.entities.add(() -> entity);
		elements.items
				.add(() -> new SpawnEggItem(entity, -39322, -10092544, new Item.Properties().group(ItemGroup.MISC)).setRegistryName("ant_spawn_egg"));
	}

	@Override
	public void init(FMLCommonSetupEvent event) {
		for (Biome biome : ForgeRegistries.BIOMES.getValues()) {
			biome.getSpawns(EntityClassification.MONSTER).add(new Biome.SpawnListEntry(entity, 12, 6, 10));
		}
		EntitySpawnPlacementRegistry.register(entity, EntitySpawnPlacementRegistry.PlacementType.ON_GROUND, Heightmap.Type.MOTION_BLOCKING_NO_LEAVES,
				MonsterEntity::canMonsterSpawn);
		DungeonHooks.addDungeonMob(entity, 180);
	}

	@SubscribeEvent
	@OnlyIn(Dist.CLIENT)
	public void registerModels(ModelRegistryEvent event) {
		RenderingRegistry.registerEntityRenderingHandler(entity, renderManager -> {
			return new MobRenderer(renderManager, new ModelGiant_red_Ant(), 0.5f) {
				{
					this.addLayer(new GlowingLayer<>(this));
				}
				@Override
				public ResourceLocation getEntityTexture(Entity entity) {
					return new ResourceLocation("mnthings:textures/giant_red_ant.png");
				}
			};
		});
	}
	public static class CustomEntity extends CreatureEntity {
		public CustomEntity(FMLPlayMessages.SpawnEntity packet, World world) {
			this(entity, world);
		}

		public CustomEntity(EntityType<CustomEntity> type, World world) {
			super(type, world);
			experienceValue = 1;
			setNoAI(false);
			enablePersistence();
			this.setItemStackToSlot(EquipmentSlotType.MAINHAND, new ItemStack(Blocks.ACACIA_LEAVES, (int) (1)));
		}

		@Override
		public IPacket<?> createSpawnPacket() {
			return NetworkHooks.getEntitySpawningPacket(this);
		}

		@Override
		protected void registerGoals() {
			super.registerGoals();
			this.targetSelector.addGoal(1, new NearestAttackableTargetGoal(this, PlayerEntity.class, false, true));
			this.targetSelector.addGoal(2, new NearestAttackableTargetGoal(this, BushmanEntity.CustomEntity.class, false, true));
			this.goalSelector.addGoal(3, new MeleeAttackGoal(this, 1.2, false));
			this.goalSelector.addGoal(4, new RandomWalkingGoal(this, 1));
			this.targetSelector.addGoal(5, new HurtByTargetGoal(this).setCallsForHelp(this.getClass()));
			this.goalSelector.addGoal(6, new LookRandomlyGoal(this));
			this.goalSelector.addGoal(7, new SwimGoal(this));
		}

		@Override
		public CreatureAttribute getCreatureAttribute() {
			return CreatureAttribute.ARTHROPOD;
		}

		@Override
		public boolean canDespawn(double distanceToClosestPlayer) {
			return false;
		}

		protected void dropSpecialItems(DamageSource source, int looting, boolean recentlyHitIn) {
			super.dropSpecialItems(source, looting, recentlyHitIn);
			this.entityDropItem(new ItemStack(Blocks.ACACIA_LEAVES, (int) (1)));
		}

		@Override
		public net.minecraft.util.SoundEvent getAmbientSound() {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("mnthings:ant"));
		}

		@Override
		public net.minecraft.util.SoundEvent getHurtSound(DamageSource ds) {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("mnthings:ant"));
		}

		@Override
		public net.minecraft.util.SoundEvent getDeathSound() {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.generic.death"));
		}

		@Override
		public boolean attackEntityFrom(DamageSource source, float amount) {
			if (source == DamageSource.FALL)
				return false;
			if (source == DamageSource.CACTUS)
				return false;
			return super.attackEntityFrom(source, amount);
		}

		@Override
		protected void registerAttributes() {
			super.registerAttributes();
			if (this.getAttribute(SharedMonsterAttributes.MOVEMENT_SPEED) != null)
				this.getAttribute(SharedMonsterAttributes.MOVEMENT_SPEED).setBaseValue(0.3);
			if (this.getAttribute(SharedMonsterAttributes.MAX_HEALTH) != null)
				this.getAttribute(SharedMonsterAttributes.MAX_HEALTH).setBaseValue(5);
			if (this.getAttribute(SharedMonsterAttributes.ARMOR) != null)
				this.getAttribute(SharedMonsterAttributes.ARMOR).setBaseValue(0);
			if (this.getAttribute(SharedMonsterAttributes.ATTACK_DAMAGE) == null)
				this.getAttributes().registerAttribute(SharedMonsterAttributes.ATTACK_DAMAGE);
			this.getAttribute(SharedMonsterAttributes.ATTACK_DAMAGE).setBaseValue(3);
		}

		public void livingTick() {
			super.livingTick();
			double x = this.getPosX();
			double y = this.getPosY();
			double z = this.getPosZ();
			Random random = this.rand;
			Entity entity = this;
			if (true)
				for (int l = 0; l < 4; ++l) {
					double d0 = (x + random.nextFloat());
					double d1 = (y + random.nextFloat());
					double d2 = (z + random.nextFloat());
					int i1 = random.nextInt(2) * 2 - 1;
					double d3 = (random.nextFloat() - 0.5D) * 0.5D;
					double d4 = (random.nextFloat() - 0.5D) * 0.5D;
					double d5 = (random.nextFloat() - 0.5D) * 0.5D;
					world.addParticle(ParticleTypes.ENCHANTED_HIT, d0, d1, d2, d3, d4, d5);
				}
		}
	}

	@OnlyIn(Dist.CLIENT)
	private static class GlowingLayer<T extends Entity, M extends EntityModel<T>> extends LayerRenderer<T, M> {
		public GlowingLayer(IEntityRenderer<T, M> er) {
			super(er);
		}

		public void render(MatrixStack matrixStackIn, IRenderTypeBuffer bufferIn, int packedLightIn, T entitylivingbaseIn, float limbSwing,
				float limbSwingAmount, float partialTicks, float ageInTicks, float netHeadYaw, float headPitch) {
			IVertexBuilder ivertexbuilder = bufferIn.getBuffer(RenderType.getEyes(new ResourceLocation("mnthings:textures/giant_red_ant_glow.png")));
			this.getEntityModel().render(matrixStackIn, ivertexbuilder, 15728640, OverlayTexture.NO_OVERLAY, 1, 1, 1, 1);
		}
	}

	// Made with Blockbench 3.8.4
	// Exported for Minecraft version 1.15 - 1.16
	// Paste this class into your mod and generate all required imports
	public static class ModelGiant_red_Ant extends EntityModel<Entity> {
		private final ModelRenderer cabeza;
		private final ModelRenderer cuerpo1;
		private final ModelRenderer cuerpo2;
		private final ModelRenderer patas;
		private final ModelRenderer der1;
		private final ModelRenderer izq1;
		private final ModelRenderer der2;
		private final ModelRenderer izq2;
		private final ModelRenderer cuello;
		public ModelGiant_red_Ant() {
			textureWidth = 32;
			textureHeight = 32;
			cabeza = new ModelRenderer(this);
			cabeza.setRotationPoint(0.5F, 22.0F, -3.0F);
			cabeza.setTextureOffset(0, 7).addBox(-2.5F, -1.0F, -3.0F, 5.0F, 2.0F, 3.0F, 0.0F, false);
			cabeza.setTextureOffset(4, 12).addBox(-1.5F, 0.0F, -4.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(0, 12).addBox(0.5F, 0.0F, -4.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(0, 2).addBox(1.5F, 0.4F, -5.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(0, 0).addBox(-2.5F, 0.4F, -5.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cuerpo1 = new ModelRenderer(this);
			cuerpo1.setRotationPoint(0.0F, 22.0F, 0.0F);
			cuerpo1.setTextureOffset(0, 0).addBox(-1.0F, -1.0F, -2.0F, 3.0F, 2.0F, 5.0F, 0.0F, false);
			cuerpo2 = new ModelRenderer(this);
			cuerpo2.setRotationPoint(0.0F, 22.0F, 0.0F);
			cuerpo2.setTextureOffset(11, 0).addBox(-1.0F, -1.0F, 5.0F, 3.0F, 2.0F, 1.0F, 0.0F, false);
			cuerpo2.setTextureOffset(11, 3).addBox(-1.0F, 0.0F, 6.0F, 3.0F, 1.0F, 1.0F, 0.0F, false);
			patas = new ModelRenderer(this);
			patas.setRotationPoint(0.0F, 22.0F, 0.0F);
			der1 = new ModelRenderer(this);
			der1.setRotationPoint(-0.9F, 1.0F, -1.6F);
			patas.addChild(der1);
			der1.setTextureOffset(0, 0).addBox(-1.1F, 0.0F, -0.4F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			izq1 = new ModelRenderer(this);
			izq1.setRotationPoint(1.9F, 1.0F, -1.5F);
			patas.addChild(izq1);
			izq1.setTextureOffset(0, 0).addBox(0.1F, 0.0F, -0.5F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			der2 = new ModelRenderer(this);
			der2.setRotationPoint(-1.0F, 1.0F, 2.5F);
			patas.addChild(der2);
			der2.setTextureOffset(0, 0).addBox(-1.0F, 0.0F, -0.5F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			izq2 = new ModelRenderer(this);
			izq2.setRotationPoint(1.9F, 1.0F, 2.5F);
			patas.addChild(izq2);
			izq2.setTextureOffset(0, 0).addBox(0.1F, 0.0F, -0.5F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cuello = new ModelRenderer(this);
			cuello.setRotationPoint(0.0F, 24.0F, 0.0F);
			cuello.setTextureOffset(0, 26).addBox(-1.0F, -2.0F, -3.0F, 3.0F, 1.0F, 8.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			cabeza.render(matrixStack, buffer, packedLight, packedOverlay);
			cuerpo1.render(matrixStack, buffer, packedLight, packedOverlay);
			cuerpo2.render(matrixStack, buffer, packedLight, packedOverlay);
			patas.render(matrixStack, buffer, packedLight, packedOverlay);
			cuello.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.izq1.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.izq2.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.cabeza.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.cabeza.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.der1.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.der2.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
		}
	}
}
