
package net.mcreator.mnthings.entity;

import net.minecraftforge.registries.ObjectHolder;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.fml.network.NetworkHooks;
import net.minecraftforge.fml.network.FMLPlayMessages;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.world.gen.Heightmap;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.DamageSource;
import net.minecraft.network.IPacket;
import net.minecraft.nbt.CompoundNBT;
import net.minecraft.item.SpawnEggItem;
import net.minecraft.item.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.Item;
import net.minecraft.entity.projectile.AbstractArrowEntity;
import net.minecraft.entity.passive.AnimalEntity;
import net.minecraft.entity.ai.goal.WaterAvoidingRandomWalkingGoal;
import net.minecraft.entity.ai.goal.SwimGoal;
import net.minecraft.entity.ai.goal.RangedAttackGoal;
import net.minecraft.entity.ai.goal.RandomWalkingGoal;
import net.minecraft.entity.ai.goal.PanicGoal;
import net.minecraft.entity.ai.goal.LookRandomlyGoal;
import net.minecraft.entity.ai.goal.FollowParentGoal;
import net.minecraft.entity.ai.goal.BreedGoal;
import net.minecraft.entity.ai.goal.BreakBlockGoal;
import net.minecraft.entity.SpawnReason;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.MobEntity;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.IRendersAsItem;
import net.minecraft.entity.IRangedAttackMob;
import net.minecraft.entity.ILivingEntityData;
import net.minecraft.entity.EntityType;
import net.minecraft.entity.EntitySpawnPlacementRegistry;
import net.minecraft.entity.EntityClassification;
import net.minecraft.entity.Entity;
import net.minecraft.entity.CreatureAttribute;
import net.minecraft.entity.AgeableEntity;
import net.minecraft.client.renderer.texture.OverlayTexture;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.layers.LayerRenderer;
import net.minecraft.client.renderer.entity.SpriteRenderer;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.IEntityRenderer;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.renderer.IRenderTypeBuffer;
import net.minecraft.client.Minecraft;
import net.minecraft.block.Blocks;

import net.mcreator.mnthings.MnthingsModElements;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@MnthingsModElements.ModElement.Tag
public class SnowlingEntity extends MnthingsModElements.ModElement {
	public static EntityType entity = null;
	@ObjectHolder("mnthings:entitybulletsnowling")
	public static final EntityType arrow = null;
	public SnowlingEntity(MnthingsModElements instance) {
		super(instance, 8);
		FMLJavaModLoadingContext.get().getModEventBus().register(this);
	}

	@Override
	public void initElements() {
		entity = (EntityType.Builder.<CustomEntity>create(CustomEntity::new, EntityClassification.AMBIENT).setShouldReceiveVelocityUpdates(true)
				.setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(CustomEntity::new).size(1f, 0.6f)).build("snowling")
						.setRegistryName("snowling");
		elements.entities.add(() -> entity);
		elements.items.add(() -> new SpawnEggItem(entity, -6710887, -6684724, new Item.Properties().group(ItemGroup.MISC))
				.setRegistryName("snowling_spawn_egg"));
		elements.entities.add(() -> (EntityType.Builder.<ArrowCustomEntity>create(ArrowCustomEntity::new, EntityClassification.MISC)
				.setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).setCustomClientFactory(ArrowCustomEntity::new)
				.size(0.5f, 0.5f)).build("entitybulletsnowling").setRegistryName("entitybulletsnowling"));
	}

	@Override
	public void init(FMLCommonSetupEvent event) {
		for (Biome biome : ForgeRegistries.BIOMES.getValues()) {
			boolean biomeCriteria = false;
			if (ForgeRegistries.BIOMES.getKey(biome).equals(new ResourceLocation("taiga")))
				biomeCriteria = true;
			if (ForgeRegistries.BIOMES.getKey(biome).equals(new ResourceLocation("snowy_tundra")))
				biomeCriteria = true;
			if (ForgeRegistries.BIOMES.getKey(biome).equals(new ResourceLocation("snowy_mountains")))
				biomeCriteria = true;
			if (ForgeRegistries.BIOMES.getKey(biome).equals(new ResourceLocation("taiga_hills")))
				biomeCriteria = true;
			if (ForgeRegistries.BIOMES.getKey(biome).equals(new ResourceLocation("snowy_taiga")))
				biomeCriteria = true;
			if (ForgeRegistries.BIOMES.getKey(biome).equals(new ResourceLocation("snowy_taiga_hills")))
				biomeCriteria = true;
			if (ForgeRegistries.BIOMES.getKey(biome).equals(new ResourceLocation("snowy_mountains")))
				biomeCriteria = true;
			if (!biomeCriteria)
				continue;
			biome.getSpawns(EntityClassification.AMBIENT).add(new Biome.SpawnListEntry(entity, 34, 4, 4));
		}
		EntitySpawnPlacementRegistry.register(entity, EntitySpawnPlacementRegistry.PlacementType.NO_RESTRICTIONS,
				Heightmap.Type.MOTION_BLOCKING_NO_LEAVES, MobEntity::canSpawnOn);
	}

	@SubscribeEvent
	@OnlyIn(Dist.CLIENT)
	public void registerModels(ModelRegistryEvent event) {
		RenderingRegistry.registerEntityRenderingHandler(entity, renderManager -> {
			return new MobRenderer(renderManager, new ModelSnowblock(), 0.5f) {
				{
					this.addLayer(new GlowingLayer<>(this));
				}
				@Override
				public ResourceLocation getEntityTexture(Entity entity) {
					return new ResourceLocation("mnthings:textures/snowblock.png");
				}
			};
		});
		RenderingRegistry.registerEntityRenderingHandler(arrow,
				renderManager -> new SpriteRenderer(renderManager, Minecraft.getInstance().getItemRenderer()));
	}
	public static class CustomEntity extends AnimalEntity implements IRangedAttackMob {
		public CustomEntity(FMLPlayMessages.SpawnEntity packet, World world) {
			this(entity, world);
		}

		public CustomEntity(EntityType<CustomEntity> type, World world) {
			super(type, world);
			experienceValue = 1;
			setNoAI(false);
		}

		@Override
		public IPacket<?> createSpawnPacket() {
			return NetworkHooks.getEntitySpawningPacket(this);
		}

		@Override
		protected void registerGoals() {
			super.registerGoals();
			this.goalSelector.addGoal(1, new PanicGoal(this, 1));
			this.goalSelector.addGoal(2, new BreedGoal(this, 1));
			this.goalSelector.addGoal(3, new FollowParentGoal(this, 1));
			this.goalSelector.addGoal(4, new BreakBlockGoal(Blocks.SNOW.getDefaultState().getBlock(), this, 1, (int) 1));
			this.goalSelector.addGoal(5, new RandomWalkingGoal(this, 0.6));
			this.goalSelector.addGoal(6, new WaterAvoidingRandomWalkingGoal(this, 0.6));
			this.goalSelector.addGoal(7, new LookRandomlyGoal(this));
			this.goalSelector.addGoal(8, new SwimGoal(this));
			this.goalSelector.addGoal(1, new RangedAttackGoal(this, 1.25, 20, 10) {
				@Override
				public boolean shouldContinueExecuting() {
					return this.shouldExecute();
				}
			});
		}

		@Override
		public CreatureAttribute getCreatureAttribute() {
			return CreatureAttribute.UNDEFINED;
		}

		@Override
		public net.minecraft.util.SoundEvent getAmbientSound() {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.generic.eat"));
		}

		@Override
		public net.minecraft.util.SoundEvent getHurtSound(DamageSource ds) {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("block.snow.hit"));
		}

		@Override
		public net.minecraft.util.SoundEvent getDeathSound() {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("block.glass.break"));
		}

		@Override
		protected void registerAttributes() {
			super.registerAttributes();
			if (this.getAttribute(SharedMonsterAttributes.MOVEMENT_SPEED) != null)
				this.getAttribute(SharedMonsterAttributes.MOVEMENT_SPEED).setBaseValue(0.3);
			if (this.getAttribute(SharedMonsterAttributes.MAX_HEALTH) != null)
				this.getAttribute(SharedMonsterAttributes.MAX_HEALTH).setBaseValue(34);
			if (this.getAttribute(SharedMonsterAttributes.ARMOR) != null)
				this.getAttribute(SharedMonsterAttributes.ARMOR).setBaseValue(5);
			if (this.getAttribute(SharedMonsterAttributes.ATTACK_DAMAGE) == null)
				this.getAttributes().registerAttribute(SharedMonsterAttributes.ATTACK_DAMAGE);
			this.getAttribute(SharedMonsterAttributes.ATTACK_DAMAGE).setBaseValue(3);
		}

		public void attackEntityWithRangedAttack(LivingEntity target, float flval) {
			ArrowCustomEntity entityarrow = new ArrowCustomEntity(arrow, this, this.world);
			double d0 = target.getPosY() + (double) target.getEyeHeight() - 1.1;
			double d1 = target.getPosX() - this.getPosX();
			double d3 = target.getPosZ() - this.getPosZ();
			entityarrow.shoot(d1, d0 - entityarrow.getPosY() + (double) MathHelper.sqrt(d1 * d1 + d3 * d3) * 0.2F, d3, 1.6F, 12.0F);
			world.addEntity(entityarrow);
		}

		@Override
		public AgeableEntity createChild(AgeableEntity ageable) {
			CustomEntity retval = (CustomEntity) entity.create(this.world);
			retval.onInitialSpawn(this.world, this.world.getDifficultyForLocation(new BlockPos(retval)), SpawnReason.BREEDING,
					(ILivingEntityData) null, (CompoundNBT) null);
			return retval;
		}

		@Override
		public boolean isBreedingItem(ItemStack stack) {
			if (stack == null)
				return false;
			if (new ItemStack(Blocks.SNOW_BLOCK, (int) (1)).getItem() == stack.getItem())
				return true;
			return false;
		}
	}

	@OnlyIn(Dist.CLIENT)
	private static class GlowingLayer<T extends Entity, M extends EntityModel<T>> extends LayerRenderer<T, M> {
		public GlowingLayer(IEntityRenderer<T, M> er) {
			super(er);
		}

		public void render(MatrixStack matrixStackIn, IRenderTypeBuffer bufferIn, int packedLightIn, T entitylivingbaseIn, float limbSwing,
				float limbSwingAmount, float partialTicks, float ageInTicks, float netHeadYaw, float headPitch) {
			IVertexBuilder ivertexbuilder = bufferIn.getBuffer(RenderType.getEyes(new ResourceLocation("mnthings:textures/snowblock_-_copia.png")));
			this.getEntityModel().render(matrixStackIn, ivertexbuilder, 15728640, OverlayTexture.NO_OVERLAY, 1, 1, 1, 1);
		}
	}

	@OnlyIn(value = Dist.CLIENT, _interface = IRendersAsItem.class)
	private static class ArrowCustomEntity extends AbstractArrowEntity implements IRendersAsItem {
		public ArrowCustomEntity(FMLPlayMessages.SpawnEntity packet, World world) {
			super(arrow, world);
		}

		public ArrowCustomEntity(EntityType<? extends ArrowCustomEntity> type, World world) {
			super(type, world);
		}

		public ArrowCustomEntity(EntityType<? extends ArrowCustomEntity> type, double x, double y, double z, World world) {
			super(type, x, y, z, world);
		}

		public ArrowCustomEntity(EntityType<? extends ArrowCustomEntity> type, LivingEntity entity, World world) {
			super(type, entity, world);
		}

		@Override
		public IPacket<?> createSpawnPacket() {
			return NetworkHooks.getEntitySpawningPacket(this);
		}

		@Override
		@OnlyIn(Dist.CLIENT)
		public ItemStack getItem() {
			return new ItemStack(Items.SNOWBALL, (int) (1));
		}

		@Override
		protected ItemStack getArrowStack() {
			return new ItemStack(Items.SNOWBALL, (int) (1));
		}
	}

	// Made with Blockbench 3.8.4
	// Exported for Minecraft version 1.15 - 1.16
	// Paste this class into your mod and generate all required imports
	public static class ModelSnowblock extends EntityModel<Entity> {
		private final ModelRenderer cabeza;
		private final ModelRenderer piernaizq1;
		private final ModelRenderer izq2;
		private final ModelRenderer piernader1;
		private final ModelRenderer piernader2;
		public ModelSnowblock() {
			textureWidth = 64;
			textureHeight = 64;
			cabeza = new ModelRenderer(this);
			cabeza.setRotationPoint(0.0F, 24.0F, 0.0F);
			cabeza.setTextureOffset(0, 13).addBox(-4.0F, -8.0F, -5.0F, 8.0F, 7.0F, 9.0F, 0.0F, false);
			cabeza.setTextureOffset(0, 0).addBox(-5.0F, -10.0F, -6.0F, 10.0F, 2.0F, 11.0F, 0.0F, false);
			cabeza.setTextureOffset(0, 15).addBox(-1.0F, -8.0F, 4.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(4, 13).addBox(-3.0F, -8.0F, 4.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(0, 13).addBox(-5.0F, -8.0F, 3.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(3, 9).addBox(-5.0F, -8.0F, 1.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(6, 8).addBox(-5.0F, -8.0F, -1.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(0, 8).addBox(-5.0F, -8.0F, -3.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(3, 7).addBox(-5.0F, -8.0F, -5.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(6, 0).addBox(2.0F, -8.0F, -6.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(0, 4).addBox(4.0F, -8.0F, -1.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(0, 6).addBox(4.0F, -8.0F, -5.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(3, 3).addBox(4.0F, -8.0F, 1.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(3, 1).addBox(4.0F, -8.0F, 3.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(0, 2).addBox(3.0F, -8.0F, 4.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(0, 0).addBox(1.0F, -8.0F, 4.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(3, 5).addBox(4.0F, -8.0F, -3.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(6, 4).addBox(-2.0F, -8.0F, -6.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(6, 2).addBox(0.0F, -8.0F, -6.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			cabeza.setTextureOffset(6, 6).addBox(-4.0F, -8.0F, -6.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			piernaizq1 = new ModelRenderer(this);
			piernaizq1.setRotationPoint(4.0F, 23.0F, -4.5F);
			piernaizq1.setTextureOffset(0, 19).addBox(0.0F, 0.0F, -0.5F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			izq2 = new ModelRenderer(this);
			izq2.setRotationPoint(4.1F, 23.0F, 3.5F);
			izq2.setTextureOffset(4, 17).addBox(-0.1F, 0.0F, -0.5F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			piernader1 = new ModelRenderer(this);
			piernader1.setRotationPoint(-4.0F, 23.0F, -4.5F);
			piernader1.setTextureOffset(0, 17).addBox(-1.0F, 0.0F, -0.5F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			piernader2 = new ModelRenderer(this);
			piernader2.setRotationPoint(-4.0F, 23.0F, 3.5F);
			piernader2.setTextureOffset(4, 15).addBox(-1.0F, 0.0F, -0.5F, 1.0F, 1.0F, 1.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			cabeza.render(matrixStack, buffer, packedLight, packedOverlay);
			piernaizq1.render(matrixStack, buffer, packedLight, packedOverlay);
			izq2.render(matrixStack, buffer, packedLight, packedOverlay);
			piernader1.render(matrixStack, buffer, packedLight, packedOverlay);
			piernader2.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.piernader2.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.piernader1.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.izq2.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.piernaizq1.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
		}
	}
}
